## dustrac 2.0.1

=== CMakeLists.txt ===
project(DustRacing2D)

cmake_minimum_required(VERSION 2.8.12)
cmake_policy(VERSION 2.8.12)

if(POLICY CMP0005)
    cmake_policy(SET CMP0005 NEW)
endif()

if(POLICY CMP0020)
    cmake_policy(SET CMP0020 NEW)
endif()

# Global game version
set(VERSION_MAJOR "2")
set(VERSION_MINOR "0")
set(VERSION_PATCH "1")
set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")

option(ReleaseBuild "This should be used when creating DEB and RPM packages." OFF)

option(VorbisLibsPath "Optional path hint for vorbis libs (libvorbis, libvorbisfile)." "")

option(OggLibPath "Optional path hint for ogg lib (libogg)." "")

option(USC "Enable install layout required by Ubuntu Software Center i.e. installs to /opt." OFF)

option(DATA_PATH "Optional DATA_PATH for Linux release build." "")

option(BIN_PATH "Optional BIN_PATH for Linux release build." "")

option(DOC_PATH "Optional DOC_PATH for Linux release build." "")

option(GLES "Build for OpenGL ES 2.0" OFF)

option(NO_GLEW "Don't use GLEW to resolve OpenGL extensions if enabled." ON)

option(QOpenGLFunctions "Use QOpenGLFunctions to resolve OpenGL extensions if enabled." ON)

# Default to release C++ flags if CMAKE_BUILD_TYPE not set
if( NOT CMAKE_BUILD_TYPE )
  set( CMAKE_BUILD_TYPE Release CACHE STRING
       "Choose the type of build, options are: None Debug Release RelWithDebInfo
MinSizeRel."
       FORCE )
endif()

if(GLES)
    add_definitions(-D__MC_GLES__)
    message(STATUS "Compiling for OpenGL ES 2.0")
else()
    message(STATUS "Compiling for OpenGL 2.1")
endif()

if(NO_GLEW)
    add_definitions(-D__MC_NO_GLEW__)
endif()

if(QOpenGLFunctions)
    message(STATUS "Using QOpenGLFunctions")
    add_definitions(-D__MC_QOPENGLFUNCTIONS__)
    add_definitions(-D__MC_NO_GLEW__)
endif()

add_definitions(-DGLEW_STATIC)
add_definitions(-DGLEW_NO_GLU)

if(UNIX)
    include("InstallLinux.cmake")
elseif(WIN32)
    include("InstallWindows.cmake")
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR MINGW OR ${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
    add_compile_options("$<$<CONFIG:RELASE>:-W -Wall -O3 -pedantic -fomit-frame-pointer>")
    add_compile_options("$<$<CONFIG:DEBUG>:-W -Wall -O0 -g -pedantic>")
elseif(MSVC)
    add_definitions(-DNOMINMAX)
endif()

set(GAME_BINARY_NAME "dustrac-game")
set(EDITOR_BINARY_NAME "dustrac-editor")

add_definitions(-DVERSION="${VERSION}")

set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(QT_MIN_VER 5.2.1)
find_package(Qt5Core ${QT_MIN_VER} REQUIRED)
find_package(Qt5OpenGL ${QT_MIN_VER} REQUIRED)
find_package(Qt5Xml ${QT_MIN_VER} REQUIRED)
find_package(Qt5Widgets ${QT_MIN_VER} REQUIRED)
find_package(Qt5LinguistTools ${QT_MIN_VER} REQUIRED)
find_package(Qt5Test ${QT_MIN_VER} REQUIRED)

# Find OpenGL
find_package(OpenGL REQUIRED)

# OpenAL for sounds. OpenAL directory can be given by -DOPENALDIR=...
set(ENV{OPENALDIR} ${OpenALDir})
find_package(OpenAL REQUIRED)
include_directories(${OPENAL_INCLUDE_DIR}/..)

# Vorbis libs for reading Ogg files
if(MSVC)
    find_library(VORBISFILE_LIB NAMES libvorbisfile.a libvorbisfile_static.lib HINTS ${VorbisLibsPath} REQUIRED)
    find_library(VORBIS_LIB NAMES libvorbis.a libvorbis_static.lib HINTS ${VorbisLibsPath} REQUIRED)
    include_directories(${VorbisLibsPath}/include)
    find_library(OGG_LIB NAMES libogg.a libogg_static.lib HINTS ${OggLibPath} REQUIRED)
    include_directories(${OggLibPath}/include)
    message(STATUS "Using static versions of vorbis libs:")
    message(STATUS "  ${VORBISFILE_LIB}")
    message(STATUS "  ${VORBIS_LIB}")
    message(STATUS "  ${OGG_LIB}")
else()
    include(FindPkgConfig)
    pkg_check_modules(VORBISFILE REQUIRED vorbisfile)
endif()

# Enable CMake's unit test framework
enable_testing()

# Install paths depend on the build type and target platform
resolve_install_paths()

add_subdirectory(src/editor)
add_subdirectory(src/game)

=== src/editor/CMakeLists.txt ===
# Translation files in src/editor/translations (without .ts)
set(TS dustrac-editor_fi dustrac-editor_it dustrac-editor_cs dustrac-editor_fr dustrac-editor_de)
set(TS_FILES)
set(QM_FILES)
foreach(TS_FILE ${TS})
    list(APPEND TS_FILES ${CMAKE_SOURCE_DIR}/src/editor/translations/${TS_FILE}.ts)
    list(APPEND QM_FILES ${CMAKE_BINARY_DIR}/src/editor/${TS_FILE}.qm)
endforeach()
# Set sources
set(SRC
    aboutdlg.cpp
    application.cpp
    editordata.cpp
    editorview.cpp
    editorscene.cpp
    main.cpp
    mainwindow.cpp
    map.cpp
    newtrackdialog.cpp
    object.cpp
    objectfactory.cpp
    objectmodelloader.cpp
    rotatedialog.cpp
    targetnode.cpp
    targetnodesizedlg.cpp
    tileanimator.cpp
    trackdata.cpp
    trackio.cpp
    tracktile.cpp
    trackpropertiesdialog.cpp
    undostack.cpp
    ../common/config.cpp
    ../common/mapbase.cpp
    ../common/objectbase.cpp
    ../common/objects.cpp
    ../common/route.cpp
    ../common/targetnodebase.cpp
    ../common/trackdatabase.cpp
    ../common/tracktilebase.cpp)

set(RCS ${CMAKE_SOURCE_DIR}/data/images/editor.qrc ${CMAKE_SOURCE_DIR}/data/icons/icons.qrc)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../common)

qt5_add_resources(RC_SRC ${RCS})
qt5_add_translation(QM ${TS_FILES})
qt5_wrap_ui(UI_HDRS ${UIS})

# We need this to be able to include headers produced by uic in our code
include_directories(${CMAKE_BINARY_DIR})

# Resource compilation for MinGW
if(MINGW)
    add_custom_command(
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/windowsrc.o
        COMMAND
            ${CMAKE_RC_COMPILER}
            -I${CMAKE_SOURCE_DIR} -i${CMAKE_SOURCE_DIR}/data/icons/WindowsEditor.rc
            -o ${CMAKE_CURRENT_BINARY_DIR}/windowsrc.o)
    set(SRC ${SRC} ${CMAKE_CURRENT_BINARY_DIR}/windowsrc.o)
endif()

# Copy desktop file
if(ReleaseBuild AND UNIX)
    set(DesktopFileSourcePath)
    if(USC)
        set(DesktopFileSourcePath ${CMAKE_SOURCE_DIR}/src/dustrac-editor.desktop.opt.in)
    else()
        set(DesktopFileSourcePath ${CMAKE_SOURCE_DIR}/src/dustrac-editor.desktop.in)
    endif()
    add_custom_target(desktop-file-editor ALL
        COMMAND cmake -E copy ${DesktopFileSourcePath}
            ${CMAKE_BINARY_DIR}/dustrac-editor.desktop
    DEPENDS ${EDITOR_BINARY_NAME})
endif()

# Add the executable
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR})
add_executable(${EDITOR_BINARY_NAME} WIN32 ${SRC} ${MOC_SRC} ${RC_SRC} ${UI_HDRS} ${QM})

target_link_libraries(${EDITOR_BINARY_NAME} Qt5::Widgets Qt5::Xml)
set_property(TARGET ${EDITOR_BINARY_NAME} PROPERTY CXX_STANDARD 11)

foreach(TS_FILE ${TS})
    # Make targets to copy generated qm files to data dir. This is done the hard
    # way, because qt4_add_translation() generates the qm files to ${CMAKE_CURRENT_SOURCE_DIR}
    add_custom_target(copy-translation-file-${TS_FILE} ALL
        COMMAND cmake -E copy ${CMAKE_BINARY_DIR}/src/editor/${TS_FILE}.qm
            ${CMAKE_BINARY_DIR}/data/translations/${TS_FILE}.qm
        DEPENDS ${EDITOR_BINARY_NAME})
endforeach()

=== src/game/CMakeLists.txt ===
# Sub build: MiniCore engine
add_subdirectory(MiniCore)

# Sub build: Menu Toolkit From Hell
add_subdirectory(MTFH)

# Sub build: Sound Toolkit From Hell
add_subdirectory(STFH)

# Engine include paths
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/MiniCore/src/Asset")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/MiniCore/src/Core")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/MiniCore/src/Graphics")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/MiniCore/src/Particles")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/MiniCore/src/Physics")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/MiniCore/src/Text")

# Menu toolkit and menu include paths
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/MTFH")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/menu")

# Sound toolkit include paths
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/STFH")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/audio")

# Translation files in src/game/translations (without .ts)
set(TS dustrac-game_fi dustrac-game_it dustrac-game_cs dustrac-game_fr dustrac-game_de)
set(TS_FILES)
set(QM_FILES)
foreach(TS_FILE ${TS})
    list(APPEND TS_FILES ${CMAKE_SOURCE_DIR}/src/game/translations/${TS_FILE}.ts)
    list(APPEND QM_FILES ${CMAKE_BINARY_DIR}/src/game/${TS_FILE}.qm)
endforeach()

# Set headers that don't have a corresponding cpp file
set(HDR
    layers.hpp
    shaders.h
    shaders30.h
    ../common/userexception.hpp
)

# Set sources
set(SRC
    ai.cpp
    application.cpp
    bridge.cpp
    bridgetrigger.cpp
    car.cpp
    carfactory.cpp
    carparticleeffectmanager.cpp
    carphysicscomponent.cpp
    carsoundeffectmanager.cpp
    carstatusview.cpp
    checkeredflag.cpp
    crashoverlay.cpp
    difficultyprofile.cpp
    eventhandler.cpp
    fadeanimation.cpp
    fontfactory.cpp
    game.cpp
    graphicsfactory.cpp
    inputhandler.cpp
    intro.cpp
    main.cpp
    map.cpp
    messageoverlay.cpp
    minimap.cpp
    particlefactory.cpp
    pit.cpp
    offtrackdetector.cpp
    overlaybase.cpp
    race.cpp
    renderer.cpp
    scene.cpp
    settings.cpp
    startlights.cpp
    startlightsoverlay.cpp
    statemachine.cpp
    timing.cpp
    timingoverlay.cpp
    tire.cpp
    track.cpp
    trackdata.cpp
    trackloader.cpp
    trackobject.cpp
    trackobjectfactory.cpp
    tracktile.cpp
    tree.cpp
    ../common/config.cpp
    ../common/objectbase.cpp
    ../common/objects.cpp
    ../common/route.cpp
    ../common/targetnodebase.cpp
    ../common/trackdatabase.cpp
    ../common/tracktilebase.cpp
    ../common/mapbase.cpp
    audio/audioworker.cpp
    audio/audiosource.cpp
    audio/openaldata.cpp
    audio/openaldevice.cpp
    audio/openalsource.cpp
    audio/openaloggdata.cpp
    audio/openalwavdata.cpp
    menu/confirmationmenu.cpp
    menu/credits.cpp
    menu/difficultymenu.cpp
    menu/help.cpp
    menu/keyconfigmenu.cpp
    menu/lapcountmenu.cpp
    menu/mainmenu.cpp
    menu/resolutionmenu.cpp
    menu/settingsmenu.cpp
    menu/surfacemenu.cpp
    menu/textmenuitemview.cpp
    menu/trackselectionmenu.cpp
    menu/vsyncmenu.cpp
    )

set(RCS ${CMAKE_SOURCE_DIR}/data/icons/icons.qrc)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

qt5_add_resources(RC_SRC ${RCS})
qt5_add_translation(QM ${TS_FILES})

# Copy desktop file
if(ReleaseBuild AND UNIX)
    set(DesktopFileSourcePath)
    if(USC)
        set(DesktopFileSourcePath ${CMAKE_SOURCE_DIR}/src/dustrac-game.desktop.opt.in)
    else()
        set(DesktopFileSourcePath ${CMAKE_SOURCE_DIR}/src/dustrac-game.desktop.in)
    endif()
    add_custom_target(desktop-file-game ALL
        COMMAND cmake -E copy ${DesktopFileSourcePath}
            ${CMAKE_BINARY_DIR}/dustrac-game.desktop
    DEPENDS ${GAME_BINARY_NAME})
endif()

# Resource compilation for MinGW
if(MINGW)
    add_custom_command(
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/windowsrc.o
        COMMAND
            ${CMAKE_RC_COMPILER}
            -I${CMAKE_SOURCE_DIR} -i${CMAKE_SOURCE_DIR}/data/icons/WindowsGame.rc
            -o ${CMAKE_CURRENT_BINARY_DIR}/windowsrc.o)
    set(SRC ${SRC} ${CMAKE_CURRENT_BINARY_DIR}/windowsrc.o)
endif()

# The main game executable
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR})
add_executable(${GAME_BINARY_NAME} WIN32 ${HDR} ${SRC} ${MOC_SRC} ${RC_SRC} ${QM})

set(COMMON_LIBS
    MiniCore
    MTFH
    STFH
    ${OPENGL_gl_LIBRARY}
    ${OPENGL_glu_LIBRARY}
    ${OPENAL_LIBRARY}
    ${VORBISFILE_LIBRARIES}
    ${VORBISFILE_LIB} # Valid only with MSVC
    ${VORBIS_LIB}     # Valid only with MSVC
    ${OGG_LIB})       # Valid only with MSVC

target_link_libraries(${GAME_BINARY_NAME} ${COMMON_LIBS} Qt5::OpenGL Qt5::Xml)
set_property(TARGET ${GAME_BINARY_NAME} PROPERTY CXX_STANDARD 11)

foreach(TS_FILE ${TS})
    # Make targets to copy generated qm files to data dir. This is done the hard
    # way, because qt4_add_translation() generates the qm files to ${CMAKE_CURRENT_SOURCE_DIR}
    add_custom_target(copy-translation-file-${TS_FILE} ALL
        COMMAND cmake -E copy ${CMAKE_BINARY_DIR}/src/game/${TS_FILE}.qm
            ${CMAKE_BINARY_DIR}/data/translations/${TS_FILE}.qm
        DEPENDS ${GAME_BINARY_NAME})
endforeach()

=== src/game/MTFH/CMakeLists.txt ===
project(MTFH)

include_directories("${CMAKE_CURRENT_SOURCE_DIR}")

set(MTFHSRC
    animationcurve.cpp
    menu.cpp
    menuitem.cpp
    menuitemaction.cpp
    menumanager.cpp
    menuitemview.cpp)

add_library(MTFH ${MTFHSRC})

=== src/game/MiniCore/CMakeLists.txt ===
project(MiniCore)

cmake_minimum_required(VERSION 2.8.12)
cmake_policy(VERSION 2.8.12)

if(POLICY CMP0005)
    cmake_policy(SET CMP0005 NEW)
endif()

if(POLICY CMP0020)
    cmake_policy(SET CMP0020 NEW)
endif()

if(POLICY CMP0043)
    cmake_policy(SET CMP0043 NEW)
endif()

if(POLICY CMP0054)
    cmake_policy(SET CMP0054 NEW)
endif()

option(GLES "Build for OpenGL ES 2.0" OFF)

option(NO_GLEW "Don't use GLEW to resolve OpenGL extensions if enabled." ON)

option(QOpenGLFunctions "Use QOpenGLFunctions to resolve OpenGL extensions if enabled." ON)

if(GLES)
    add_definitions(-D__MC_GLES__)
    message(STATUS "Compiling for OpenGL ES 2.0")
else()
    message(STATUS "Compiling for OpenGL 2.1")
endif()

if(NO_GLEW)
    add_definitions(-D__MC_NO_GLEW__)
endif()

if(QOpenGLFunctions)
    message(STATUS "Using QOpenGLFunctions")
    add_definitions(-D__MC_QOPENGLFUNCTIONS__)
    add_definitions(-D__MC_NO_GLEW__)
endif()

add_definitions(-DGLEW_STATIC)
add_definitions(-DGLEW_NO_GLU)

if(CMAKE_COMPILER_IS_GNUCXX OR MINGW OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    add_compile_options("$<$<CONFIG:RELASE>:-W -Wall -O3 -pedantic -fomit-frame-pointer>")
    add_compile_options("$<$<CONFIG:DEBUG>:-W -Wall -O0 -g -pedantic>")
elseif(MSVC)
    add_definitions(-DNOMINMAX)
endif()

add_definitions(-DVERSION="${VERSION}")

set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(QT_MIN_VER 5.2.1)
find_package(Qt5Core ${QT_MIN_VER} REQUIRED)
find_package(Qt5OpenGL ${QT_MIN_VER} REQUIRED)
find_package(Qt5Xml ${QT_MIN_VER} REQUIRED)
find_package(Qt5Widgets ${QT_MIN_VER} REQUIRED)

# Find OpenGL
find_package(OpenGL REQUIRED)

# Enable CMake's unit test framework
enable_testing()

add_subdirectory(src)

=== src/game/STFH/CMakeLists.txt ===
project(STFH)

include_directories("${CMAKE_CURRENT_SOURCE_DIR}")

set(STFHSRC
    data.cpp
    device.cpp
    listener.cpp
    location.cpp
    source.cpp
)

add_library(STFH ${STFHSRC})

=== src/game/MiniCore/src/CMakeLists.txt ===
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/Asset")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/Core")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/Graphics")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/Physics")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/Text")

set(MiniCoreSRC
Asset/mcassetmanager.cc
Asset/mcmeshconfigloader.cc
Asset/mcmeshloader.cc
Asset/mcmeshmanager.cc
Asset/mcmeshobjectdata.cc
Asset/mcsurfaceobjectdata.cc
Asset/mcsurfaceconfigloader.cc
Asset/mcsurfacemanager.cc
Core/mcbbox.hh
Core/mcbbox3d.hh
Core/mcevent.cc
Core/mclogger.cc
Core/mcmathutil.cc
Core/mcmacros.hh
Core/mcobbox.hh
Core/mcobject.cc
Core/mcobjectcomponent.cc
Core/mcobjectdata.cc
Core/mcobjectfactory.cc
Core/mcrandom.cc
Core/mctimerevent.cc
Core/mctrigonom.cc
Core/mctyperegistry.cc
Core/mcvectoranimation.cc
Core/mcvector2d.hh
Core/mcvector3d.hh
Core/mcworld.cc
Graphics/mccamera.cc
Graphics/mcglambientlight.cc
Graphics/mcgldiffuselight.cc
Graphics/mcglmaterial.cc
Graphics/mcglobjectbase.cc
Graphics/mcglscene.cc
Graphics/mcglshaderprogram.cc
Graphics/mcmesh.cc
Graphics/mcmeshview.cc
Graphics/mcobjectrendererbase.cc
Graphics/mcparticle.cc
Graphics/mcparticlerendererbase.cc
Graphics/mcrenderlayer.cc
Graphics/mcshaders.hh
Graphics/mcshaders30.hh
Graphics/mcshadersGLES.hh
Graphics/mcshapeview.cc
Graphics/mcsurfaceparticle.cc
Graphics/mcsurfaceobjectrenderer.cc
Graphics/mcsurfaceobjectrendererlegacy.cc
Graphics/mcsurfaceparticlerenderer.cc
Graphics/mcsurfaceparticlerendererlegacy.cc
Graphics/mcsurface.cc
Graphics/mcsurfaceview.cc
Graphics/mcworldrenderer.cc
Physics/mccircleshape.cc
Physics/mccollisiondetector.cc
Physics/mccollisionevent.cc
Physics/mccontact.cc
Physics/mcdragforcegenerator.cc
Physics/mcforcegenerator.cc
Physics/mcforceregistry.cc
Physics/mcfrictiongenerator.cc
Physics/mcgravitygenerator.cc
Physics/mcimpulsegenerator.cc
Physics/mcobjectgrid.cc
Physics/mcoutofboundariesevent.cc
Physics/mcphysicscomponent.cc
Physics/mcrectshape.cc
Physics/mcshape.cc
Physics/mcspringforcegenerator.cc
Physics/mcspringforcegenerator2dfast.cc
Text/mctexturefont.cc
Text/mctexturefontconfigloader.cc
Text/mctexturefontdata.cc
Text/mctexturefontmanager.cc
Text/mctextureglyph.cc
Text/mctexturetext.cc
)

if(NOT QOpenGLFunctions)
set(MiniCoreSRC ${MiniCoreSRC} Graphics/contrib/glew/glew.c)
endif()

set(MiniCoreTargetName MiniCore)
add_library(${MiniCoreTargetName} ${MiniCoreSRC})
target_link_libraries(${MiniCoreTargetName} Qt5::Core Qt5::OpenGL Qt5::Xml)
set_property(TARGET ${MiniCoreTargetName} PROPERTY CXX_STANDARD 11)

add_subdirectory(UnitTests)

=== src/game/MiniCore/src/UnitTests/MCForceRegistryTest/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../../Core)

set(SRC MCForceRegistryTest.cpp)

set(EXECUTABLE_OUTPUT_PATH ${CMAKE_SOURCE_DIR}/unittests)
add_executable(MCForceRegistryTest ${SRC} ${MOC_SRC})
target_link_libraries(MCForceRegistryTest MiniCore ${OPENGL_gl_LIBRARY} ${OPENGL_glu_LIBRARY})
add_test(MCForceRegistryTest ${CMAKE_SOURCE_DIR}/unittests/MCForceRegistryTest)

qt5_use_modules(MCForceRegistryTest OpenGL Xml Test)

=== src/game/MiniCore/src/UnitTests/MCMeshLoaderTest/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../../Core)

set(SRC MCMeshLoaderTest.cpp)

set(EXECUTABLE_OUTPUT_PATH ${CMAKE_SOURCE_DIR}/unittests)
add_executable(MCMeshLoaderTest ${SRC} ${MOC_SRC})
target_link_libraries(MCMeshLoaderTest MiniCore)
add_test(MCMeshLoaderTest ${CMAKE_SOURCE_DIR}/unittests/MCMeshLoaderTest)

qt5_use_modules(MCMeshLoaderTest Test)

=== src/game/MiniCore/src/UnitTests/MCObjectTest/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../../Core)

set(SRC MCObjectTest.cpp)

set(EXECUTABLE_OUTPUT_PATH ${CMAKE_SOURCE_DIR}/unittests)
add_executable(MCObjectTest ${SRC} ${MOC_SRC})
target_link_libraries(MCObjectTest MiniCore ${OPENGL_gl_LIBRARY} ${OPENGL_glu_LIBRARY})
add_test(MCObjectTest ${CMAKE_SOURCE_DIR}/unittests/MCObjectTest)

qt5_use_modules(MCObjectTest OpenGL Xml Test)

=== src/game/MiniCore/src/UnitTests/MCWorldTest/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../../Core)

set(SRC MCWorldTest.cpp)

set(EXECUTABLE_OUTPUT_PATH ${CMAKE_SOURCE_DIR}/unittests)
add_executable(MCWorldTest ${SRC} ${MOC_SRC})
target_link_libraries(MCWorldTest MiniCore ${OPENGL_gl_LIBRARY} ${OPENGL_glu_LIBRARY})
add_test(MCWorldTest ${CMAKE_SOURCE_DIR}/unittests/MCWorldTest)

qt5_use_modules(MCWorldTest OpenGL Xml Test)

=== debian/changelog ===
dustrac (2.0.1-1) unstable; urgency=medium

  * Initial release.

 -- Pino Toscano <pino@debian.org>  Wed, 10 Jan 2018 23:25:25 +0100

=== debian/control ===
Source: dustrac
Section: games
Priority: optional
Maintainer: Pino Toscano <pino@debian.org>
Build-Depends: debhelper (>= 10),
 cmake (>= 3.1),
 pkg-config,
 qtbase5-dev,
 libqt5opengl5-dev,
 qttools5-dev,
 libopenal-dev,
 libvorbis-dev,
 xauth,
 xvfb,
Standards-Version: 4.1.3
Homepage: https://juzzlin.github.io/DustRacing2D/

Package: dustracing2d
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 dustracing2d-data (>= ${source:Version}),
Description: tile-based 2D racing game
 Dust Racing (Dustrac) is a tile-based, cross-platform 2D racing game.
 .
 Dust Racing comes with a level editor for easy level creation.
 .
 Features:
  * 1-2 human players against 11 challenging computer players
  * 3 difficulty settings: Easy, Medium, Senna
  * Split-screen two player game (vertical or horizontal)
  * Game modes: Race, Time Trial, Duel
  * 2D graphics with some 3D objects
  * Smooth game play and physics
  * Multiple race tracks
  * Finishing in TOP-6 will unlock the next race track
  * Star ratings based on the best positions on each race track
  * Easy to create new race tracks with the level editor
  * Engine and collision sounds
  * Pit stops
  * Runs windowed or fullscreen

Package: dustracing2d-data
Architecture: all
Depends: ${misc:Depends},
 fonts-dejavu-core,
Description: data files for Dust Racing 2D
 Dust Racing (Dustrac) is a tile-based, cross-platform 2D racing game.
 .
 This package contains the data files for Dust Racing 2D.

## dustrac 2.0.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,6 +2,8 @@
 
 cmake_minimum_required(VERSION 2.8.12)
 cmake_policy(VERSION 2.8.12)
+
+# Use cmake --help-policy [POLICY] for more information about these:
 
 if(POLICY CMP0005)
     cmake_policy(SET CMP0005 NEW)
@@ -11,19 +13,39 @@
     cmake_policy(SET CMP0020 NEW)
 endif()
 
+# Default to GLVND
+if(POLICY CMP0072)
+    cmake_policy(SET CMP0072 OLD)
+endif()
+
+if(POLICY CMP0043)
+    cmake_policy(SET CMP0043 NEW)
+endif()
+
 # Global game version
-set(VERSION_MAJOR "2")
-set(VERSION_MINOR "0")
-set(VERSION_PATCH "1")
+set(VERSION_MAJOR 2)
+set(VERSION_MINOR 0)
+set(VERSION_PATCH 5)
 set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
 
-option(ReleaseBuild "This should be used when creating DEB and RPM packages." OFF)
+# Some common CPack variables
+set(CPACK_PACKAGE_VERSION_MAJOR ${VERSION_MAJOR})
+set(CPACK_PACKAGE_VERSION_MINOR ${VERSION_MINOR})
+set(CPACK_PACKAGE_VERSION_PATCH ${VERSION_PATCH})
+
+set(CPACK_PACKAGE_NAME dustracing2d)
+set(CPACK_PACKAGE_VENDOR Juzzlin)
+set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "")
+set(CPACK_PACKAGE_ICON ${CMAKE_SOURCE_DIR}/data/images/about.png)
+
+set(CPACK_RESOURCE_FILE_LICENSE ${CMAKE_SOURCE_DIR}/COPYING)
+set(CPACK_RESOURCE_FILE_README ${CMAKE_SOURCE_DIR}/README.md)
+
+option(ReleaseBuild "This should be used when creating a build with install targets" OFF)
 
 option(VorbisLibsPath "Optional path hint for vorbis libs (libvorbis, libvorbisfile)." "")
 
 option(OggLibPath "Optional path hint for ogg lib (libogg)." "")
-
-option(USC "Enable install layout required by Ubuntu Software Center i.e. installs to /opt." OFF)
 
 option(DATA_PATH "Optional DATA_PATH for Linux release build." "")
 
@@ -36,6 +58,8 @@
 option(NO_GLEW "Don't use GLEW to resolve OpenGL extensions if enabled." ON)
 
 option(QOpenGLFunctions "Use QOpenGLFunctions to resolve OpenGL extensions if enabled." ON)
+
+option(UnlockAllTracks "Unlock all tracks (for development purposes)" OFF)
 
 # Default to release C++ flags if CMAKE_BUILD_TYPE not set
 if( NOT CMAKE_BUILD_TYPE )
@@ -62,6 +86,11 @@
     add_definitions(-D__MC_NO_GLEW__)
 endif()
 
+if (UnlockAllTracks)
+    message(STATUS "All tracks unlocked")
+    add_definitions(-DUNLOCK_ALL_TRACKS)
+endif()
+
 add_definitions(-DGLEW_STATIC)
 add_definitions(-DGLEW_NO_GLU)
 
@@ -72,9 +101,16 @@
 endif()
 
 if(CMAKE_COMPILER_IS_GNUCXX OR MINGW OR ${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
-    add_compile_options("$<$<CONFIG:RELASE>:-W -Wall -O3 -pedantic -fomit-frame-pointer>")
-    add_compile_options("$<$<CONFIG:DEBUG>:-W -Wall -O0 -g -pedantic>")
+    add_compile_options("$<$<CONFIG:RELEASE>:-W;-Wall;-O3;-pedantic;-fomit-frame-pointer>")
+    add_compile_options("$<$<CONFIG:DEBUG>:-W;-Wall;-O0;-pedantic>")
+
+    # Automatically use ccache if found
+    find_program(CCACHE_FOUND ccache)
+    if(CCACHE_FOUND)
+        set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
+        set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
+    endif(CCACHE_FOUND)
+
 elseif(MSVC)
     add_definitions(-DNOMINMAX)
 endif()
@@ -86,7 +122,7 @@
 
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
-set(QT_MIN_VER 5.2.1)
+set(QT_MIN_VER 5.4.0)
 find_package(Qt5Core ${QT_MIN_VER} REQUIRED)
 find_package(Qt5OpenGL ${QT_MIN_VER} REQUIRED)
 find_package(Qt5Xml ${QT_MIN_VER} REQUIRED)
@@ -96,6 +132,11 @@
 
 # Find OpenGL
 find_package(OpenGL REQUIRED)
+if(${CMAKE_VERSION} VERSION_LESS "3.11.0")
+    set(DUSTRAC_OPENGL_LIBS ${OPENGL_gl_LIBRARY})
+else()
+    set(DUSTRAC_OPENGL_LIBS OpenGL::GL)
+endif()
 
 # OpenAL for sounds. OpenAL directory can be given by -DOPENALDIR=...
 set(ENV{OPENALDIR} ${OpenALDir})
@@ -124,5 +165,8 @@
 # Install paths depend on the build type and target platform
 resolve_install_paths()
 
+add_subdirectory(src/contrib/SimpleLogger)
+include_directories(src/contrib/SimpleLogger/src)
+
 add_subdirectory(src/editor)
 add_subdirectory(src/game)

=== src/editor/CMakeLists.txt ===
--- 
+++ 
@@ -1,21 +1,26 @@
 # Translation files in src/editor/translations (without .ts)
-set(TS dustrac-editor_fi dustrac-editor_it dustrac-editor_cs dustrac-editor_fr dustrac-editor_de)
+set(TS dustrac-editor_fi dustrac-editor_it dustrac-editor_cs dustrac-editor_fr dustrac-editor_de dustrac-editor_ru)
 set(TS_FILES)
 set(QM_FILES)
 foreach(TS_FILE ${TS})
     list(APPEND TS_FILES ${CMAKE_SOURCE_DIR}/src/editor/translations/${TS_FILE}.ts)
-    list(APPEND QM_FILES ${CMAKE_BINARY_DIR}/src/editor/${TS_FILE}.qm)
+    list(APPEND QM_FILES ${CMAKE_BINARY_DIR}/data/translations/${TS_FILE}.qm)
 endforeach()
+set_source_files_properties(${TS_FILES} PROPERTIES OUTPUT_LOCATION ${CMAKE_BINARY_DIR}/data/translations)
+
 # Set sources
 set(SRC
     aboutdlg.cpp
     application.cpp
+    draganddropstore.cpp
     editordata.cpp
     editorview.cpp
-    editorscene.cpp
+    editormode.hpp
+    floodfill.cpp
     main.cpp
     mainwindow.cpp
     map.cpp
+    mediator.cpp
     newtrackdialog.cpp
     object.cpp
     objectfactory.cpp
@@ -29,7 +34,7 @@
     tracktile.cpp
     trackpropertiesdialog.cpp
     undostack.cpp
-    ../common/config.cpp
+    ../common/config.hpp
     ../common/mapbase.cpp
     ../common/objectbase.cpp
     ../common/objects.cpp
@@ -79,13 +84,4 @@
 add_executable(${EDITOR_BINARY_NAME} WIN32 ${SRC} ${MOC_SRC} ${RC_SRC} ${UI_HDRS} ${QM})
 
 target_link_libraries(${EDITOR_BINARY_NAME} Qt5::Widgets Qt5::Xml)
-set_property(TARGET ${EDITOR_BINARY_NAME} PROPERTY CXX_STANDARD 11)
-
-foreach(TS_FILE ${TS})
-    # Make targets to copy generated qm files to data dir. This is done the hard
-    # way, because qt4_add_translation() generates the qm files to ${CMAKE_CURRENT_SOURCE_DIR}
-    add_custom_target(copy-translation-file-${TS_FILE} ALL
-        COMMAND cmake -E copy ${CMAKE_BINARY_DIR}/src/editor/${TS_FILE}.qm
-            ${CMAKE_BINARY_DIR}/data/translations/${TS_FILE}.qm
-        DEPENDS ${EDITOR_BINARY_NAME})
-endforeach()
+set_property(TARGET ${EDITOR_BINARY_NAME} PROPERTY CXX_STANDARD 14)

=== src/game/CMakeLists.txt ===
--- 
+++ 
@@ -24,13 +24,14 @@
 include_directories("${CMAKE_CURRENT_SOURCE_DIR}/audio")
 
 # Translation files in src/game/translations (without .ts)
-set(TS dustrac-game_fi dustrac-game_it dustrac-game_cs dustrac-game_fr dustrac-game_de)
+set(TS dustrac-game_fi dustrac-game_it dustrac-game_cs dustrac-game_fr dustrac-game_de dustrac-game_ru)
 set(TS_FILES)
 set(QM_FILES)
 foreach(TS_FILE ${TS})
     list(APPEND TS_FILES ${CMAKE_SOURCE_DIR}/src/game/translations/${TS_FILE}.ts)
-    list(APPEND QM_FILES ${CMAKE_BINARY_DIR}/src/game/${TS_FILE}.qm)
+    list(APPEND QM_FILES ${CMAKE_BINARY_DIR}/data/translations/${TS_FILE}.qm)
 endforeach()
+set_source_files_properties(${TS_FILES} PROPERTIES OUTPUT_LOCATION ${CMAKE_BINARY_DIR}/data/translations)
 
 # Set headers that don't have a corresponding cpp file
 set(HDR
@@ -45,7 +46,6 @@
     ai.cpp
     application.cpp
     bridge.cpp
-    bridgetrigger.cpp
     car.cpp
     carfactory.cpp
     carparticleeffectmanager.cpp
@@ -59,6 +59,7 @@
     fadeanimation.cpp
     fontfactory.cpp
     game.cpp
+    gearbox.cpp
     graphicsfactory.cpp
     inputhandler.cpp
     intro.cpp
@@ -87,7 +88,8 @@
     trackobjectfactory.cpp
     tracktile.cpp
     tree.cpp
-    ../common/config.cpp
+    ../common/config.hpp
+    ../common/datakeywords.hpp
     ../common/objectbase.cpp
     ../common/objects.cpp
     ../common/route.cpp
@@ -157,22 +159,13 @@
     MiniCore
     MTFH
     STFH
-    ${OPENGL_gl_LIBRARY}
-    ${OPENGL_glu_LIBRARY}
     ${OPENAL_LIBRARY}
     ${VORBISFILE_LIBRARIES}
     ${VORBISFILE_LIB} # Valid only with MSVC
     ${VORBIS_LIB}     # Valid only with MSVC
     ${OGG_LIB})       # Valid only with MSVC
 
-target_link_libraries(${GAME_BINARY_NAME} ${COMMON_LIBS} Qt5::OpenGL Qt5::Xml)
-set_property(TARGET ${GAME_BINARY_NAME} PROPERTY CXX_STANDARD 11)
+target_link_libraries(${GAME_BINARY_NAME} ${COMMON_LIBS} Qt5::OpenGL Qt5::Xml ${DUSTRAC_OPENGL_LIBS} SimpleLogger)
+set_property(TARGET ${GAME_BINARY_NAME} PROPERTY CXX_STANDARD 14)
 
-foreach(TS_FILE ${TS})
-    # Make targets to copy generated qm files to data dir. This is done the hard
-    # way, because qt4_add_translation() generates the qm files to ${CMAKE_CURRENT_SOURCE_DIR}
-    add_custom_target(copy-translation-file-${TS_FILE} ALL
-        COMMAND cmake -E copy ${CMAKE_BINARY_DIR}/src/game/${TS_FILE}.qm
-            ${CMAKE_BINARY_DIR}/data/translations/${TS_FILE}.qm
-        DEPENDS ${GAME_BINARY_NAME})
-endforeach()
+add_subdirectory(unittests)

=== src/contrib/SimpleLogger/CMakeLists.txt ===
project(SimpleLogger)

cmake_minimum_required(VERSION 2.8.12)
cmake_policy(VERSION 2.8.12)

option(SIMPLE_LOGGER_BUILD_SHARED_LIB "Build a shared library" OFF)

set(VERSION_MAJOR "1")
set(VERSION_MINOR "1")
set(VERSION_PATCH "0")
set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")

# Default to release C++ flags if CMAKE_BUILD_TYPE not set
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo
MinSizeRel." FORCE)
endif()

set(CMAKE_CXX_STANDARD 11)

if(CMAKE_COMPILER_IS_GNUCXX OR MINGW OR ${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wpedantic")

    # CMAKE_CXX_STANDARD supported only by versions >= 3.1
    if (CMAKE_VERSION VERSION_LESS "3.1")
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++11")
    endif ()
endif()

set(LIBRARY_NAME "SimpleLogger")

set(CMAKE_INCLUDE_CURRENT_DIR ON)

add_subdirectory(src)

=== src/contrib/SimpleLogger/src/CMakeLists.txt ===
set(SRC simple_logger.cpp)
set(HDR simple_logger.hpp)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

# This is the "object library" target: compiles the sources only once
add_library(objlib OBJECT ${SRC})

# Shared libraries need PIC
set_property(TARGET objlib PROPERTY POSITION_INDEPENDENT_CODE 1)

set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR})
if(${SIMPLE_LOGGER_SHARED_LIB})
    add_library(${LIBRARY_NAME} SHARED $<TARGET_OBJECTS:objlib>)
else()
    add_library(${LIBRARY_NAME} STATIC $<TARGET_OBJECTS:objlib>)
endif()
set_target_properties(${LIBRARY_NAME} PROPERTIES VERSION ${VERSION} SOVERSION ${VERSION_MAJOR})
set_target_properties(${LIBRARY_NAME} PROPERTIES PUBLIC_HEADER ${HDR})

=== src/game/unittests/gearboxtest/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

set(NAME gearboxtest)
set(SRC ${NAME}.cpp ../../gearbox.cpp)

set(EXECUTABLE_OUTPUT_PATH ${CMAKE_SOURCE_DIR}/unittests)
add_executable(${NAME} ${SRC} ${MOC_SRC})
set_property(TARGET ${NAME} PROPERTY CXX_STANDARD 11)
target_link_libraries(${NAME} Qt5::Test)
add_test(${NAME} ${CMAKE_SOURCE_DIR}/unittests/${NAME})

=== src/game/MiniCore/src/UnitTests/MCWorldTest/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../../Core)

set(SRC MCWorldTest.cpp)

set(EXECUTABLE_OUTPUT_PATH ${CMAKE_SOURCE_DIR}/unittests)
add_executable(MCWorldTest ${SRC} ${MOC_SRC})
set_property(TARGET MCWorldTest PROPERTY CXX_STANDARD 11)

target_link_libraries(MCWorldTest MiniCore ${OPENGL_gl_LIBRARY} ${OPENGL_glu_LIBRARY} Qt5::OpenGL Qt5::Xml Qt5::Test)
add_test(MCWorldTest ${CMAKE_SOURCE_DIR}/unittests/MCWorldTest)

=== debian/changelog ===
dustrac (2.0.5-1) unstable; urgency=medium

  * New upstream release. (Closes: #951427)
  * Switch the libqt5opengl5-dev build dependency to libqt5opengl5-desktop-dev,
    as only the Desktop OpenGL is supported.
  * Update the build dependencies according to the upstream build system:
    - bump Qt packages to 5.4.0
  * Bump the debhelper compatibility to 12:
    - switch the debhelper build dependency to debhelper-compat 12
    - remove debian/compat
  * Update copyright.
  * Bump Standards-Version to 4.5.0, no changes required.

 -- Pino Toscano <pino@debian.org>  Wed, 19 Feb 2020 21:32:46 +0100

=== debian/control ===
--- 
+++ 
@@ -2,17 +2,17 @@
 Section: games
 Priority: optional
 Maintainer: Pino Toscano <pino@debian.org>
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper-compat (= 12),
  cmake (>= 3.1),
  pkg-config,
- qtbase5-dev,
- libqt5opengl5-dev,
- qttools5-dev,
+ qtbase5-dev (>= 5.4.0~),
+ libqt5opengl5-desktop-dev (>= 5.4.0~),
+ qttools5-dev (>= 5.4.0~),
  libopenal-dev,
  libvorbis-dev,
  xauth,
  xvfb,
-Standards-Version: 4.1.3
+Standards-Version: 4.5.0
 Homepage: https://juzzlin.github.io/DustRacing2D/
 
 Package: dustracing2d

=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

%:
	dh $@ --buildsystem cmake

override_dh_auto_configure:
	dh_auto_configure -Scmake -- \
	  -DReleaseBuild=ON \
	  -DBIN_PATH=/usr/games/ \
	  -DDOC_PATH=/usr/share/doc/dustracing2d/ \
	  -DDATA_PATH=/usr/share/games/dustracing2d/

ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
override_dh_auto_test:
	xvfb-run dh_auto_test
endif

override_dh_auto_install:
	dh_auto_install
	# replace the shipped DejaVu font with a link to the packaged version
	find debian/tmp -name DejaVuSans-Bold.ttf -exec ln -sf /usr/share/fonts/truetype/dejavu/DejaVuSans-Bold.ttf {} \;
	find debian/tmp -name LICENCE.txt -delete

override_dh_missing:
	dh_missing --fail-missing

## dustrac 2.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -24,8 +24,8 @@
 
 # Global game version
 set(VERSION_MAJOR 2)
-set(VERSION_MINOR 0)
-set(VERSION_PATCH 5)
+set(VERSION_MINOR 1)
+set(VERSION_PATCH 0)
 set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
 
 # Some common CPack variables
@@ -128,6 +128,7 @@
 find_package(Qt5Xml ${QT_MIN_VER} REQUIRED)
 find_package(Qt5Widgets ${QT_MIN_VER} REQUIRED)
 find_package(Qt5LinguistTools ${QT_MIN_VER} REQUIRED)
+find_package(Qt5Sql ${QT_MIN_VER} REQUIRED)
 find_package(Qt5Test ${QT_MIN_VER} REQUIRED)
 
 # Find OpenGL
@@ -159,14 +160,17 @@
     pkg_check_modules(VORBISFILE REQUIRED vorbisfile)
 endif()
 
+add_subdirectory(src/contrib/SimpleLogger EXCLUDE_FROM_ALL)
+include_directories(src/contrib/SimpleLogger/src)
+
+add_subdirectory(src/contrib/Argengine EXCLUDE_FROM_ALL)
+include_directories(src/contrib/Argengine/src)
+
 # Enable CMake's unit test framework
 enable_testing()
 
 # Install paths depend on the build type and target platform
 resolve_install_paths()
 
-add_subdirectory(src/contrib/SimpleLogger)
-include_directories(src/contrib/SimpleLogger/src)
-
 add_subdirectory(src/editor)
 add_subdirectory(src/game)

=== src/editor/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,6 @@
 # Translation files in src/editor/translations (without .ts)
-set(TS dustrac-editor_fi dustrac-editor_it dustrac-editor_cs dustrac-editor_fr dustrac-editor_de dustrac-editor_ru)
+set(TS dustrac-editor_fi dustrac-editor_it dustrac-editor_cs dustrac-editor_fr dustrac-editor_de dustrac-editor_ru 
+dustrac-editor_nl)
 set(TS_FILES)
 set(QM_FILES)
 foreach(TS_FILE ${TS})
@@ -83,5 +84,5 @@
 set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR})
 add_executable(${EDITOR_BINARY_NAME} WIN32 ${SRC} ${MOC_SRC} ${RC_SRC} ${UI_HDRS} ${QM})
 
-target_link_libraries(${EDITOR_BINARY_NAME} Qt5::Widgets Qt5::Xml)
+target_link_libraries(${EDITOR_BINARY_NAME} Qt5::Widgets Qt5::Xml Argengine_static)
 set_property(TARGET ${EDITOR_BINARY_NAME} PROPERTY CXX_STANDARD 14)

=== src/game/CMakeLists.txt ===
--- 
+++ 
@@ -24,7 +24,7 @@
 include_directories("${CMAKE_CURRENT_SOURCE_DIR}/audio")
 
 # Translation files in src/game/translations (without .ts)
-set(TS dustrac-game_fi dustrac-game_it dustrac-game_cs dustrac-game_fr dustrac-game_de dustrac-game_ru)
+set(TS dustrac-game_fi dustrac-game_it dustrac-game_cs dustrac-game_fr dustrac-game_de dustrac-game_ru dustrac-game_nl)
 set(TS_FILES)
 set(QM_FILES)
 foreach(TS_FILE ${TS})
@@ -54,6 +54,7 @@
     carstatusview.cpp
     checkeredflag.cpp
     crashoverlay.cpp
+    database.cpp
     difficultyprofile.cpp
     eventhandler.cpp
     fadeanimation.cpp
@@ -165,7 +166,7 @@
     ${VORBIS_LIB}     # Valid only with MSVC
     ${OGG_LIB})       # Valid only with MSVC
 
-target_link_libraries(${GAME_BINARY_NAME} ${COMMON_LIBS} Qt5::OpenGL Qt5::Xml ${DUSTRAC_OPENGL_LIBS} SimpleLogger)
+target_link_libraries(${GAME_BINARY_NAME} ${COMMON_LIBS} Qt5::OpenGL Qt5::Sql Qt5::Xml ${DUSTRAC_OPENGL_LIBS} SimpleLogger_static Argengine_static)
 set_property(TARGET ${GAME_BINARY_NAME} PROPERTY CXX_STANDARD 14)
 
 add_subdirectory(unittests)

=== debian/changelog ===
dustrac (2.1.0-1) unstable; urgency=medium

  * New upstream release.
  * Update the patches:
    - upstream_Include-stdexcept-for-std-runtime_error.patch: drop, backported
      from upstream
    - upstream_appdata-a-couple-of-fixes.patch: drop, backported from upstream
  * Update copyright.
  * Depend on libqt5sql5-sqlite, needed for the SQLite settings DB.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Pino Toscano <pino@debian.org>  Thu, 29 Oct 2020 08:44:12 +0100

dustrac (2.0.5-2) unstable; urgency=medium

  * Backport upstream commit d41a46ac32038055bfc9fe9a907e199ed74e371c to
    <stdexcept> where needed, fixing the build with GCC 10; patch
    upstream_Include-stdexcept-for-std-runtime_error.patch. (Closes: #957154)
  * Add Rules-Requires-Root: no.
  * Bump the debhelper compatibility to 13:
    - stop passing --fail-missing to dh_missing, as it is the default now
  * Stop adding the as-needed linker flag, as it is the default in binutils.
  * Backport upstream commit f133fdcdcc8c3db4c86304bb1feccdedfa400301 to fix
    few issues in the AppStream file; patch
    upstream_appdata-a-couple-of-fixes.patch.

 -- Pino Toscano <pino@debian.org>  Thu, 23 Jul 2020 07:42:30 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: games
 Priority: optional
 Maintainer: Pino Toscano <pino@debian.org>
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
  cmake (>= 3.1),
  pkg-config,
  qtbase5-dev (>= 5.4.0~),
@@ -13,12 +13,14 @@
  xauth,
  xvfb,
 Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: https://juzzlin.github.io/DustRacing2D/
 
 Package: dustracing2d
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
  dustracing2d-data (>= ${source:Version}),
+ libqt5sql5-sqlite,
 Description: tile-based 2D racing game
  Dust Racing (Dustrac) is a tile-based, cross-platform 2D racing game.
  .

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,4 @@
 #!/usr/bin/make -f
-
-export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed
 
 %:
 	dh $@ --buildsystem cmake
@@ -22,6 +20,3 @@
 	# replace the shipped DejaVu font with a link to the packaged version
 	find debian/tmp -name DejaVuSans-Bold.ttf -exec ln -sf /usr/share/fonts/truetype/dejavu/DejaVuSans-Bold.ttf {} \;
 	find debian/tmp -name LICENCE.txt -delete
-
-override_dh_missing:
-	dh_missing --fail-missing
